// This file is part of Moonlight Creator
//   Copyright (C) 1996-1998  Stephane Rehel
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/*
  MLImageWritter.h

  Stephane Rehel

  August 19 1997
*/

#ifndef __MLImageWriter_h
#define __MLImageWriter_h

#include <stdio.h>

#ifndef __MLString_h
#include "tools/MLString.h"
#endif

#ifndef __MLImageFormat_h
#include "MLImageFormat.h"
#endif

class MLImage;

/////////////////////////////////////////////////////////////////////////////

class MLImageWriter
{
protected:
  MLString error;
  FILE* file;

public:
  MLImageWriter();

  virtual ~MLImageWriter();

  virtual boolean available() const;

  virtual void close();

  const MLString& getError() const
    {
    return error;
    }

  virtual boolean open( const MLString& filename );

  virtual boolean write( MLImage* image );

  virtual MLImageFormat::FORMAT getFormat() const = 0;

  static MLImageWriter* getWriter( MLImageFormat::FORMAT fmt );
};

/////////////////////////////////////////////////////////////////////////////

#endif // ifndef __MLImageWriter_h
