// This file is part of Moonlight Creator
//   Copyright (C) 1996-1998  Stephane Rehel
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/*
  PTEGreen.C

  Stephane Rehel

  October 25 1997
*/

#include "tools/file/MLWFileBlock.h"
#include "tools/file/MLRFileBlock.h"

#include "graphics/mlgl.h"
#include "graphics/MLEvent.h"
#include "graphics/SystemWindow.h"

#include "PTEGreen.h"

/////////////////////////////////////////////////////////////////////////////

PTEGreen::PTEGreen( PhotoCanvas* _canvas ): PTEColored(_canvas)
{
  setName("Green");

  scale.red= 0.;
  scale.green= 1.;
  scale.blue= 0.;
  scale.alpha= 0.;
}

/////////////////////////////////////////////////////////////////////////////

PTEGreen::~PTEGreen()
{}

/////////////////////////////////////////////////////////////////////////////

void PTEGreen::write( MLWFileBlock& block )
{
  PTEColored::write(block);

  block << int(0);
}

/////////////////////////////////////////////////////////////////////////////

void PTEGreen::read( MLRFileBlock& block )
{
  PTEColored::read(block);

  if( block.getInteger() == 0 )
    return;
}

/////////////////////////////////////////////////////////////////////////////

void PTEGreen::resetAll()
{
  PTEColored::resetAll();
}

/////////////////////////////////////////////////////////////////////////////
