// This file is part of Moonlight Creator
//   Copyright (C) 1996-1998  Stephane Rehel
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifndef __ColorsList_h
#define __ColorsList_h

#ifndef __Color_h
#include "Color.h"
#endif

#define Color_Aquamarine        Color( .439216, .858824, .576471 )
#define Color_Black             Color( 0      , 0      , 0       )
#define Color_Blue              Color( 0      , 0      , 1       )
#define Color_BlueViolet        Color( .623529, .372549, .623529 )
#define Color_Brown             Color( .647059, .164706, .164706 )
#define Color_CadetBlue         Color( .372549, .623529, .623529 )
#define Color_Coral             Color( 1      , .498039, 0       )
#define Color_CornflowerBlue    Color( .258824, .258824, .435294 )
#define Color_Cyan              Color( 0      , 1      , 1       )
#define Color_DarkGreen         Color( .184314, .309804, .184314 )
#define Color_DarkOliveGreen    Color( .309804, .309804, .184314 )
#define Color_DarkOrchid        Color( .6     , .196078, .8      )
#define Color_DarkSlateBlue     Color( .419608, .137255, .556863 )
#define Color_DarkSlateGray     Color( .184314, .309804, .309804 )
#define Color_DarkSlateGrey     Color( .184314, .309804, .309804 )
#define Color_DarkTurquoise     Color( .439216, .576471, .858824 )
#define Color_DimGray           Color( .329412, .329412, .329412 )
#define Color_DimGrey           Color( .329412, .329412, .329412 )
#define Color_Firebrick         Color( .556863, .137255, .137255 )
#define Color_ForestGreen       Color( .137255, .556863, .137255 )
#define Color_Gold              Color( .8     , .498039, .196078 )
#define Color_Goldenrod         Color( .858824, .858824, .439216 )
#define Color_Gray              Color( .752941, .752941, .752941 )
#define Color_Green             Color( 0      , 1      , 0       )
#define Color_GreenYellow       Color( .576471, .858824, .439216 )
#define Color_Grey              Color( .752941, .752941, .752941 )
#define Color_IndianRed         Color( .309804, .184314, .184314 )
#define Color_Khaki             Color( .623529, .623529, .372549 )
#define Color_LightBlue         Color( .74902 , .847059, .847059 )
#define Color_LightGray         Color( .658824, .658824, .658824 )
#define Color_LightGrey         Color( .658824, .658824, .658824 )
#define Color_LightSteelBlue    Color( .560784, .560784, .737255 )
#define Color_LimeGreen         Color( .196078, .8     , .196078 )
#define Color_Magenta           Color( 1      , 0      , 1       )
#define Color_Maroon            Color( .556863, .137255, .419608 )
#define Color_MediumAquamarine  Color( .196078, .8     , .6      )
#define Color_MediumBlue        Color( .196078, .196078, .8      )
#define Color_MediumForestGreen Color( .419608, .556863, .137255 )
#define Color_MediumGoldenrod   Color( .917647, .917647, .678431 )
#define Color_MediumOrchid      Color( .576471, .439216, .858824 )
#define Color_MediumSeaGreen    Color( .258824, .435294, .258824 )
#define Color_MediumSlateBlue   Color( .498039, 0      , 1       )
#define Color_MediumSpringGreen Color( .498039, 1      , 0       )
#define Color_MediumTurquoise   Color( .439216, .858824, .858824 )
#define Color_MediumVioletRed   Color( .858824, .439216, .576471 )
#define Color_MidnightBlue      Color( .184314, .184314, .309804 )
#define Color_Navy              Color( .137255, .137255, .556863 )
#define Color_NavyBlue          Color( .137255, .137255, .556863 )
#define Color_Orange            Color( .8     , .196078, .196078 )
#define Color_OrangeRed         Color( 1      , 0      , .498039 )
#define Color_Orchid            Color( .858824, .439216, .858824 )
#define Color_PaleGreen         Color( .560784, .737255, .560784 )
#define Color_Pink              Color( .737255, .560784, .560784 )
#define Color_Plum              Color( .917647, .678431, .917647 )
#define Color_Red               Color( 1      , 0      , 0       )
#define Color_Salmon            Color( .435294, .258824, .258824 )
#define Color_SeaGreen          Color( .137255, .556863, .419608 )
#define Color_Sienna            Color( .556863, .419608, .137255 )
#define Color_SkyBlue           Color( .196078, .6     , .8      )
#define Color_SlateBlue         Color( 0      , .498039, 1       )
#define Color_SpringGreen       Color( 0      , 1      , .498039 )
#define Color_SteelBlue         Color( .137255, .419608, .556863 )
#define Color_Tan               Color( .858824, .576471, .439216 )
#define Color_Thistle           Color( .847059, .74902 , .847059 )
#define Color_Turquoise         Color( .678431, .917647, .917647 )
#define Color_Violet            Color( .309804, .184314, .309804 )
#define Color_VioletRed         Color( .8     , .196078, .6      )
#define Color_Wheat             Color( .847059, .847059, .74902  )
#define Color_White             Color( .988235, .988235, .988235 )
#define Color_Yellow            Color( 1      , 1      , 0       )
#define Color_YellowGreen       Color( .6     , .8     , .196078 )

#endif // __ColorsList_h

